searchNodes=[{"doc":"Generate localized routes and route helper modules. This module when use d , provides a localize/1 macro that is designed to wrap the standard Phoenix route macros such as get/3 , put/3 and resources/3 and localizes them for each locale defined in a Gettext backend module attached to a Cldr backend module. Translations for the parts of a given route path are translated at compile-time and are then combined into a localised route that is added to the standard Phoenix routing framework. As a result, users can enter URLs using localised terms which can enhance user engagement and content relevance. Similarly, localised path and URL helpers are generated that wrap the standard Phoenix helpers to supporting generating localised paths and URLs. Configuration A Cldr backend module that configures a Gettext asosciated backend is required. Path parts (the parts between &quot;/&quot;) are translated at compile time using Gettext . Therefore localization can only be applied to locales that are defined in a gettext backend module that is configured in a Cldr backend module. For example: defmodule MyApp.Cldr do use Cldr , locales : [ &quot;en&quot; , &quot;fr&quot; ] , default_locale : &quot;en&quot; . gettext : MyApp.Gettext providers : [ Cldr.Route ] end Here the MyApp.Cldr backend module is used to instrospect the configured locales in order to drive the localization generation. Next, configure the router module to use the localize/1 macro by adding use MyApp.Cldr.Route to the module and invoke the localize/1 macro to wrap the required routes. For example: defmodule MyApp.Router do use Phoenix.Router use MyApp.Cldr.Routes localize do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UserController end end The following routes are generated in the MyApp.Router module (assuming that translations are updated in the Gettext configuration). For this example, the :fr and :de translations are the same as the :en text with _fr or _de appended. % mix phx.routes MyApp.Router page_de_path GET /pages_de/:page PageController :show page_en_path GET /pages/:page PageController :show page_fr_path GET /pages_fr/:page PageController :show user_de_path GET /users_de UserController :index user_de_path GET /users_de/:id/edit UserController :edit user_de_path GET /users_de/new UserController :new user_de_path GET /users_de/:id UserController :show ... It is also possible to emit the routes and route helpers before localization using the mix phx.routes task on an automatically generated mini-router. See h MyApp.Router.LocalizedRoutes . Interpolating Locale Data A route may be defined with elements of the locale interpolated into it. These interpolations are specified using the normal \#{} interpolation syntax. However since route translation occurs at compile time only the following interpolations are supported: locale will interpolate the Cldr locale name language will interpolate the Cldr language name territory will interpolate the Cldr territory code Some examples are: localize do get &quot;/ \#{ locale } /locale/pages/:page&quot; , PageController , :show get &quot;/ \#{ language } /language/pages/:page&quot; , PageController , :show get &quot;/ \#{ territory } /territory/pages/:page&quot; , PageController , :show end Localized Helpers Manually constructing the localized helper names shown in the example above would be tedious. Therefore a LocalizedHelpers module is generated at compile-time. Assuming the router module is called MyApp.Router then the full name of the localized helper module is MyApp.Router.LocalizedHelpers . The functions on this module are the non-localized versions. Localised routes can be printed by leveraging the phx.routes mix task. For example: % mix phx . routes MyApp.Router page_de_path GET / pages_de / :page PageController :show page_en_path GET / pages / :page PageController :show page_fr_path GET / pages_fr / :page PageController :show user_de_path GET / users_de UserController :index user_de_path GET / users_de / :id / edit UserController :edit user_de_path GET / users_de / new UserController :new user_de_path GET / users_de / :id UserController :show user_de_path POST / users_de UserController :create user_de_path PATCH / users_de / :id UserController :update PUT / users_de / :id UserController :update ... .. The functions on the MyApp.Router.LocalizedHelpers module all respect the current locale, based upon Cldr.get_locale/1 , and will delegate to the appropriate localized function in the MyApp.Router.Helpers module created automatically by Phoenix at compile time. Configuring Localized Helpers as default Since LocalizedHelpers have the same semantics and API as the standard Helpers module it is possible to update the generated Phoenix configuration to use the LocalizedHelpers module by default. Assuming the presence of myapp_web.ex defining the module MyAppWeb then changing the view_helpers function from defp view_helpers do quote do ... import MyAppWeb.ErrorHelpers import MyAppWeb.Gettext alias MyAppWeb.Router.Helpers , as : Routes end end to defp view_helpers do quote do ... import MyAppWeb.ErrorHelpers import MyAppWeb.Gettext alias MyAppWeb.Router.LocalizedHelpers , as : Routes end end will result in the automatic use of the localized helpers rather than the standard helpers. Translations In order for routes to be localized, translations must be provided for each path segment. This translation is performed by Gettext.dgettext/3 with the domain &quot;routes&quot;. Therefore for each configured locale, a &quot;routes.pot&quot; file is required containing the path segment translations for that locale. Using the example Cldr backend that has &quot;en&quot; and &quot;fr&quot; Gettext locales then the directory structure would look like the following (if the default Gettext configuration is used): priv / gettext ├ ─ ─ default . pot ├ ─ ─ en │ └ ─ ─ LC_MESSAGES │ ├ ─ ─ default . po │ ├ ─ ─ errors . po │ └ ─ ─ routes . po ├ ─ ─ errors . pot └ ─ ─ fr └ ─ ─ LC_MESSAGES ├ ─ ─ default . po ├ ─ ─ errors . po └ ─ ─ routes . po","ref":"Cldr.Route.html","title":"Cldr.Route","type":"module"},{"doc":"Generates localised routes for each locale defined in a Cldr backend. This macro is intended to wrap a series of standard route definitiosn in a do block. For example: localize do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UsersController end","ref":"Cldr.Route.html#localize/1","title":"Cldr.Route.localize/1","type":"macro"},{"doc":"Generates localised routes for each locale provided. This macro is intended to wrap a series of standard route definitiosn in a do block. For example: localize [ :en , :fr ] do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UsersController end","ref":"Cldr.Route.html#localize/2","title":"Cldr.Route.localize/2","type":"macro"},{"doc":"Generates a module that implements localised helpers. It introspects the generated helpers module and creates a wrapper function that translates (at compile time) the path segments.","ref":"Cldr.Route.LocalizedHelpers.html","title":"Cldr.Route.LocalizedHelpers","type":"module"},{"doc":"For a given set of routes, define a LocalizedHelpers module that implements localized helpers.","ref":"Cldr.Route.LocalizedHelpers.html#define/3","title":"Cldr.Route.LocalizedHelpers.define/3","type":"function"},{"doc":"Generate localized routes and a localized path helper module. This module when use d , provides a localize/1 macro that is designed to wrap the standard Phoenix route macros such as get/3 , put/3 and resources/3 . The routes are localised for each locale configured in a Gettext backend module that is attached to a Cldr backend module. Translations for the parts of a given route path are performed at compile-time and are then combined into a localised route that is added to the standard Phoenix routing framework. As a result, users can enter URLs using localised terms which can enhance user engagement and content relevance. Similarly, localised path and URL helpers are generated that wrap the standard Phoenix helpers to support generating localised paths and URLs.","ref":"readme.html","title":"Cldr Routes","type":"extras"},{"doc":"A Cldr backend module that configures an associated gettext backend is required. In addition, a Gettext backend must be configured and added to the Cldr configuration. Path parts (the parts between &quot;/&quot;) are translated at compile time using Gettext . Therefore localization can only be applied to locales that are defined in a gettext backend module that is attached to a Cldr backend module. The following steps should be followed to set up the configuration for localized routes and helpers: Configure Gettext The first step is to ensure there is a configured Gettext backend module: defmodule MyApp.Gettext do use Gettext , otp_app : :my_app end Configure Cldr The next step is to configure a Cldr backend module, including configuring it with the Gettext module defined in the first step. The MyApp.Cldr backend module is used to instrospect the configured locales that drive the route and helper localization. defmodule MyApp.Cldr do use Cldr , locales : [ &quot;en&quot; , &quot;fr&quot; ] , default_locale : &quot;en&quot; . gettext : MyApp.Gettext providers : [ Cldr.Route ] end Note the addition of Cldr.Route to the :providers configuration key is required.","ref":"readme.html#setting-up","title":"Cldr Routes - Setting up","type":"extras"},{"doc":"Now we can configure the router module to use the localize/1 macro by adding use MyApp.Cldr.Routes to the module and invoke the localize/1 macro to wrap the required routes. use MyApp.Cldr.Routes must be added after use Phoenix.Router . For example: defmodule MyApp.Router do use Phoenix.Router use MyApp.Cldr.Routes localize do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UserController end end The following routes are generated (assuming that translations are updated in the Gettext configuration). For this example, the :fr translations are the same as the :en text with _fr appended. % mix phx.routes MyApp.Router page_de_path GET /pages_de/:page PageController :show page_en_path GET /pages/:page PageController :show page_fr_path GET /pages_fr/:page PageController :show user_de_path GET /users_de UserController :index user_de_path GET /users_de/:id/edit UserController :edit user_de_path GET /users_de/new UserController :new user_de_path GET /users_de/:id UserController :show ...","ref":"readme.html#define-localized-routes","title":"Cldr Routes - Define Localized Routes","type":"extras"},{"doc":"A route may be defined with elements of the locale interpolated into it. These interpolatins are specified using the normal \#{} interpolation syntax. However since route translation occurs at compile time only the following interpolations are supported: locale will interpolate the Cldr locale name language will interpolate the Cldr language name territory will interpolate the Cldr territory code Some examples are: localize do get &quot;/ \#{ locale } /locale/pages/:page&quot; , PageController , :show get &quot;/ \#{ language } /language/pages/:page&quot; , PageController , :show get &quot;/ \#{ territory } /territory/pages/:page&quot; , PageController , :show end","ref":"readme.html#interpolating-locale-data","title":"Cldr Routes - Interpolating Locale Data","type":"extras"},{"doc":"Manually constructing the localized helper names shown in the example above would be tedious. Therefore a LocalizedHelpers module is geenrated at compile-time. Assuming the router module is called MyApp.Router then the full name of the localized helper module is MyApp.Router.LocalizedHelpers . The functions on this module are the non-localized versions. For example, assuming the same configuration of routes as the earlier example: iex&gt; MyApp.Router.LocalizedHelpers . helper / 5 page_path / 3 page_path / 4 page_url / 3 page_url / 4 path / 2 static_integrity / 2 static_path / 2 static_url / 2 url / 1 user_path / 2 user_path / 3 user_path / 4 user_url / 2 user_url / 3 user_url / 4 The functions on the LocalizedHelpers module all respect the current locale, based upon Cldr.get_locale/1 , and will delegate to the appropriate localized function in the Helpers function created automatically at compile time. For example: iex&gt; MyApp.Cldr . put_locale ( &quot;en&quot; ) iex&gt; MyApp.Router.LocalizedHelpers . page_path % Plug.Conn { } , :show , 1 &quot;/pages/1&quot; iex&gt; MyApp.Cldr . put_locale ( &quot;fr&quot; ) iex&gt; MyApp.Router.LocalizedHelpers . page_path % Plug.Conn { } , :show , 1 &quot; / pages_fr / 1 Note The localized helpers translate the path based upon the :gettext_locale_name for the currently set Cldr locale. It is the developers responsibility to ensure that the locale is set appropriately before calling any localized path helpers. Configuring Localized Helpers as default Since LocalizedHelpers have the same semantics and API as the standard Helpers module it is possible to update the generated Phoenix configuration to use the LocalizedHelpers module by default. Assuming the presence of myapp_web.ex defining the module MyAppWeb then changing the view_helpers function from: defp view_helpers do quote do ... import MyAppWeb.ErrorHelpers import MyAppWeb.Gettext alias MyAppWeb.Router.Helpers , as : Routes end end to defp view_helpers do quote do ... import MyAppWeb.ErrorHelpers import MyAppWeb.Gettext alias MyAppWeb.Router.LocalizedHelpers , as : Routes end end will result in the automatic use of the localized helpers rather than the standard helpers.","ref":"readme.html#localized-helpers","title":"Cldr Routes - Localized Helpers","type":"extras"},{"doc":"In order for routes to be localized, translations must be provided for each path segment. This translation is performed by dgettext/3 with the domain &quot;routes&quot;. Therefore for each configured locale, a &quot;routes.pot&quot; file is required containing the path segment translations for that locale. Using the example Cldr backend that has &quot;en&quot; and &quot;fr&quot; Gettext locales then the directory structure would look like the following (if the default Gettext configuration is used): priv / gettext ├ ─ ─ default . pot ├ ─ ─ en │ └ ─ ─ LC_MESSAGES │ ├ ─ ─ default . po │ ├ ─ ─ errors . po │ └ ─ ─ routes . po ├ ─ ─ errors . pot └ ─ ─ fr └ ─ ─ LC_MESSAGES ├ ─ ─ default . po ├ ─ ─ errors . po └ ─ ─ routes . po The mix tasks gettext.extract and gettext.merge can be used to support the extraction of routing segments and to create new translation locales.","ref":"readme.html#translations","title":"Cldr Routes - Translations","type":"extras"},{"doc":"For each localized path, the Cldr locale is added to the :assigns for the route under the :cldr_locale key. This allows the developer to recognise which locale was used to generate the localized route.","ref":"readme.html#assigns","title":"Cldr Routes - Assigns","type":"extras"},{"doc":"The package can be installed by adding ex_cldr_routes to your list of dependencies in mix.exs . See also the section on setting up for configuring the Cldr backend module and the phoenix router. def deps do [ { :ex_cldr_routes , &quot;~&gt; 0.3.0&quot; } ] end The docs can be found at https://hexdocs.pm/ex_cldr_routes .","ref":"readme.html#installation","title":"Cldr Routes - Installation","type":"extras"},{"doc":"Copyright 2018-2020 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr Routes version 0.3.0 released on _ , 2022. For older changelogs please consult the release tag on GitHub Enhancements Add support for live routes. Thanks to @ringofhealth for the report. Closes #1. Support interpolating locale , language and territory into a route. Thanks to @rubas for the suggestion. Closes #3. For example: localize do get &quot;/ \#{ locale } /locale/pages/:page&quot; , PageController , :show , as : &quot;with_locale&quot; get &quot;/ \#{ language } /language/pages/:page&quot; , PageController , :show , as : &quot;with_language&quot; get &quot;/ \#{ territory } /territory/pages/:page&quot; , PageController , :show , as : &quot;with_territory&quot; end Uses the macros from Gettext rather than the functions when generating routes. This means that the mix tasks gettext.extract and gettext.merge now work as expected. Closes #3. Rewrite the LocalizedHelpers module that now proxies into the standard Phoenix Helpers module rather than maintaining a separate forked module. As a result: The standard Helpers module now generates helper names that have locale suffixes. That is user_path becomes user_en_path , user_fr_path and so on. The LocalizedHelpers module hosts the standard helper names (like user_path ) which will then call the appropriate standard helper depending on the result of Cldr.get_locale/1 . Add functions to output the localised routes. At compile time a module called MyApp.Router.LocalizedRoutes is created. This module hosts a __routes__/0 function which can be passed as an argument to the Phoenix standard Phoenix.Router.ConsoleFormatter.format/1 function that returns a string representation of configured localized routes. These can then be IO.puts/1 as required. In the next release a mix task will automate this process. Thanks to @rubas and @ringofhealth for their extreme patience while I worked this through. Closes #1, and #4.","ref":"changelog.html#cldr-routes-v0-3-0","title":"Changelog - Cldr Routes v0.3.0","type":"extras"},{"doc":"This is the changelog for Cldr Routes version 0.2.0 released on March 26th, 2022. For older changelogs please consult the release tag on GitHub Breaking Changes Changes the module name from Cldr.Routes to Cldr.Route to be consistent with the other ex_cldr -based libraries which use singular module names.","ref":"changelog.html#cldr-routes-v0-2-0","title":"Changelog - Cldr Routes v0.2.0","type":"extras"},{"doc":"This is the changelog for Cldr Routes version 0.1.0 released on March 26th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Initial release","ref":"changelog.html#cldr-routes-v0-1-0","title":"Changelog - Cldr Routes v0.1.0","type":"extras"}]